<cfcomponent>
<cfproperty name="locationCode" hint="uk location code" required="yes" type="string">
<cfproperty name="units" hint="units the measurements are returned in" required="no" type="string">
<cfproperty name="checkBoxVal" hint="true or false from flex combobox" required="yes" type="boolean">
<cfproperty name="userId" hint="UserId from a framework" required="yes" type="string">

<!--- --->
	<cffunction name="getForecast" access="remote" returntype="string" hint="Returns weather details for given uk location">
		<cfargument name="locationCode" type="string" required="yes">
		<cfargument name="units" type="string" required="no">
		
		<cfset var url = 'http://weather.yahooapis.com/forecastrss?p='>
		<cfset url = url & arguments.locationCode>
		
		<cfif arguments.units NEQ "">
			
			<cfif arguments.units EQ 'c'>
				<cfset url = url & '&u=c'>
			<cfelseif arguments.units EQ 'f'>
				<cfset url = url & '&u=f'>
			</cfif>
			
		</cfif>
		
		<cfhttp url="#url#" method="get" resolveurl="yes">
		</cfhttp>
	
		<cfset returnVar = CFHTTP.FileContent>

		<cfreturn returnVar>
	</cffunction>
<!--- --->

<!--- --->
	<cffunction name="populateCombo" access="remote" hint="Populates the combo for uk locations">
	
		<cfquery datasource="#application.dsn#" name="propQuery">
			SELECT [varCode], [varLocation]
			FROM [dbo].[ukLocationCodes]
			order by varlocation
		</cfquery>
		
		<cfquery dbtype="query" name="qGetCombo">
			Select varCode as data, varLocation as label
			from propQuery
			Order by varLocation
		</cfquery>
	
		<cfreturn qGetCombo>
	</cffunction>
<!--- --->

<!--- --->
	<cffunction name="setAsDefault" access="remote" returntype="string" hint="Sets a combo value as default">
		<cfargument name="locationCode" type="string" required="yes">
		<cfargument name="checkBoxVal" type="string" required="yes">
		<cfargument name="userId" type="string" required="yes">
		
		<cfset var msg = true>
		
		<cfif arguments.checkBoxVal>
		<!--- mark in db --->

		<cftry>
			<cfquery datasource="#application.dsn#" name="qGetDefault">
				SELECT [id], [varCode], [varLocation]
				FROM [dbo].[ukLocationCodes]
				Where varCode = '#arguments.locationCode#'
			</cfquery>

			<cfquery datasource="#application.dsn#">
				UPDATE [dbo].[employee]
			    SET [ukLocationCodesId] = '#qGetDefault.id#'
 			    WHERE id = '#arguments.userId#'
			</cfquery>
		
			<cfset message = 'You changed it to #qGetDefault.varlocation#'>
		
		<cfcatch>
			<cfset msg = cfcatch.Message>
		</cfcatch>
		</cftry>
		
		<cfelse>
		<!--- remove from db --->
		
			<cftry>
			
				<cfquery datasource="#application.dsn#">
					UPDATE [dbo].[employee]
					SET [ukLocationCodesId] = null
					WHERE id = '#arguments.userId#'
				</cfquery>
			
				<cfset message = 'You removed the default.'>
			
			<cfcatch>
				<cfset msg = cfcatch.Message>
			</cfcatch>
			
			</cftry>
		
		</cfif>
		
		<!--- update feed --->
		<cfscript>
			updateUserXML = createObject("component", "xml");
			// id, title, description
			updateUserXML.updateXML(arguments.userId, 'Updated default weather location' , 'You changed your default weather location. #message#');
		</cfscript>
		
		<cfreturn msg>	
	</cffunction>
<!--- --->

<!--- --->
	<cffunction name="getDefault" access="remote" returntype="struct" hint="Returns a users default uk location code">
		<cfargument name="userId" type="string" required="yes">

			<cfquery datasource="#application.dsn#" name="qGetCode">
				Select ukLocationCodesId
				From [dbo].[employee]
 			    WHERE id = '#arguments.userId#'
			</cfquery>
		
		<cfif qGetCode.ukLocationCodesId NEQ "">
		
			<cfquery datasource="#application.dsn#" name="qGetDefaultValue">
				Select varcode, varLocation
				From ukLocationCodes
				Where id = '#qGetCode.ukLocationCodesId#'
			</cfquery>

		<cfscript>
			myResult = structNew();
			structInsert(myResult, "varcode", qGetDefaultValue.varcode);
			structInsert(myResult, "varLocation", qGetDefaultValue.varLocation);
		</cfscript>

		<cfelse>
		
		<cfscript>
			myResult = structNew();
			structInsert(myResult, "varcode", 'null');
			structInsert(myResult, "varLocation", 'null');
		</cfscript>
		
		</cfif>

		<cfreturn myResult>
	</cffunction>
<!--- --->
</cfcomponent>